/**
 * For serialization of data classes
 */
abstract class SerializableBean<T> {
  Map<String, dynamic> serialize();
  T deserialize(Map<String, dynamic> data);

  /// Method for JSON deserialization
  T fromJson(Map<String, dynamic> json) {
    return deserialize(json);
  }

  /// Method for JSON serialization
  Map<String, dynamic> toJson() {
    return serialize();
  }
}
